=== debian/changelog ===
rabbitmq-server (3.7.8-4ubuntu2) disco; urgency=medium

  * Resolve issues with startup of RabbitMQ with erlang provided
    epmd daemon (LP: #1808766):
    - d/rabbitmq-server.service: Wants/After epmd.socket, aligning
      with services actually provided by erlang in Ubuntu.
    - d/control: Bump minimum erlang-* package versions to ensure
      compatibility with epmd.socket configuration.

 -- James Page <james.page@ubuntu.com>  Tue, 18 Dec 2018 09:18:27 +0000

rabbitmq-server (3.7.8-4ubuntu1) disco; urgency=medium

  [ Corey Bryant ]
  * d/gbp.conf: Update gbp configuration file.
  * d/control: Update Vcs-* links and maintainers.
  * d/control: Set minimum erlang dependencies to 1:21.1.1, according to
    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=909941#32.

  [ James Page ]
  * d/control,rules: Switch to using Python 3.

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 16 Nov 2018 10:36:50 +0000
